### Signal

# Soup Message::request-certificate

since: 3.0

#### Declaration

    gboolean
    request_certificate (
      SoupMessage* self,
      GTlsClientConnection* tls_connection,
      gpointer user_data
    )

#### Description [src]

Emitted during the `msg`‘s connection TLS handshake when `tls_connection` requests a certificate from the client.

You can set the client certificate by calling `soup_message_set_tls_client_certificate()` and returning `TRUE`. It’s possible to handle the request asynchornously by returning `TRUE` and call `soup_message_set_tls_client_certificate()` later once the certificate is available. Note that this signal is not emitted if `SoupSession:tls-interaction` was set, or if `soup_message_set_tls_client_certificate()` was called before the connection TLS handshake started.

Default handler: The default handler is called after the handlers added via `g_signal_connect()`.
Available since: 3.0

#### Parameters

`tls_connection`

  Type: `GTlsClientConnection`

  The `GTlsClientConnection`.

  The data is owned by the caller of the function.

#### Return value

Type: `gboolean`

`TRUE` to handle the request, or `FALSE` to make the connection fail with `G_TLS_ERROR_CERTIFICATE_REQUIRED`.